//
//  TGWebService.h
//  TogglService
//
//  Created by Francisco Garza on 1/30/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef enum {
    TGNotConnected,
    TGConnected,
    TGConnecting,
} TGConnectionState;

@class TGProject, TGWorkspace;

@interface TGWebService : NSObject {
@private
    id delegate;
    NSString *apiToken;
    NSString *clientName;
    
    NSArray *projects;
    NSArray *workspaces;

    BOOL isRunningRequest;
    BOOL hasPendingRequest;
    TGConnectionState state;
    NSMutableArray *requestQueue;
    NSMutableDictionary *requestQueueDict;
}
@property (assign, nonatomic) id delegate;
@property (copy, nonatomic) NSString *clientName;
@property (readonly, copy, nonatomic) NSString *apiToken;
@property (readonly, assign, nonatomic) BOOL hasPendingRequest;
@property (readonly, assign, nonatomic) TGConnectionState state;

@property (readonly, retain, nonatomic) NSArray *projects;
@property (readonly, retain, nonatomic) NSArray *workspaces;

+ (id)sharedWebService;

- (void)disconnect;
- (void)validateWithAPIToken:(NSString *)token;
- (void)authorizeWithAPIToken:(NSString *)token;

- (TGProject *)projectWithName:(NSString *)name;

- (NSString *)requestIdentifierForRepresentedObject:(id)anObj;
- (void)setRepresentedObject:(id)anObject forRequestWithIdentifier:(NSString *)ident;

- (NSString *)createTimeEntryWithValues:(NSDictionary *)values;
- (NSString *)updateTimeEntryWithValues:(NSDictionary *)values;
- (NSString *)deleteTimeEntryWithID:(NSString *)entryID;
- (NSString *)fetchWorkspaces;
- (NSString *)fetchProjects;

- (NSString *)createProjectWithValues:(NSDictionary *)values;

@end
