//
//  TGWebServiceDelegate.h
//  TogglService
//
//  Created by Francisco Garza on 1/30/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@class TGUser, TGTimeEntry, TGProject;

@protocol TGWebServiceDelegate
@optional

- (void)needsAuthorization;

- (void)authorizationFailedWithError:(NSError *)anError;
- (void)authorizationCreatedWithUser:(TGUser *)user;

- (void)validationFailedWithError:(NSError *)anError;
- (void)authorizationValidated;

- (void)didCreateTimeEntry:(TGTimeEntry *)timeEntry;
- (void)didDeleteTimeEntry:(TGTimeEntry *)timeEntry;
- (void)didUpdateTimeEntry:(TGTimeEntry *)timeEntry;

- (void)didFetchProjects:(NSArray *)projects;
- (void)didCreateProject:(TGProject *)project;

- (void)createTimeEntryFailedWithError:(NSError *)error;
- (void)deleteTimeEntry:(TGTimeEntry *)timeEntry failedWithError:(NSError *)error;
- (void)updateTimeEntry:(TGTimeEntry *)timeEntry failedWithError:(NSError *)error;

- (void)fetchProjectsFailedWIthError:(NSError *)error;
- (void)fetchWorkspacesFailedWithError:(NSError *)error;
- (void)createProjectFailedWithError:(NSError *)error;

@end


typedef enum {
    TGUnknownError = 0,
    TGObjectNotFoundError = 1,
} TGErrorCode;

extern NSString * const kTogglErrorDomain;
